// AT90USB/SUDD.c 
// Simple Usb Data-acquisition Device 
// S. Salewski 10-SEP-2007
// Start minicom with 8N1 configuration to see debug messages
// The real work happens inside of interrupt-service-routines

#include <util/delay.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include "usart_drv.h"
#include "usart_debug.h"
#include "usb_drv.h"
#include "dsp56k.h"
#include "usart_ctl.h"

int
main(void)
{
  cli();
  CLKPR = (1<<7);
  CLKPR = 0; // clock prescaler == 0, so we have 16 MHz mpu frequency with our 16 MHz crystal
  initQueue();
  USART_Init();
  //USART_WriteString("\r\n----------------------------------------------------------\r\n");
  USART_WriteString("| HVFG USB Hostadapter V1.0                              |\r\n");                               
  //USART_WriteString("----------------------------------------------------------\r\n");
  USART_WriteString("Starting device...\r\n\r\n");	
  dspsysInitIO();
  
  //UsbDevLaunchDevice(false);
  //UsbDevWaitStartupFinished(); // no reason to wait
  USART_WriteString("Device operational...\r\n\r\n");	
  int i = 0; // to suppress warning of avr-gcc
  uint8_t res;
  //sei();
  while (1)
  {
//		_delay_ms(100);
//		Debug("t");
  		rwcmd_t cmd;
		while (i<255)
	    {
	      asm volatile ("nop"); // necessary for avr-gcc 4.x to prevent removing of empty delay loop
		  i++;
	    }
		if(UsbDevIsUnderflowErrorFlagSet())
		{ 
			Debug("Buffer underflow\r\n");
			UsbDevClearUnderflowErrorFlag();
		}
		cmd=dequeueCmd(&res);
		if (res > 0)
		{
			switch (cmd.type)
			{
				case CMD_READ:
					dspsysReadRegister(cmd.addr, &(cmd.data));
					Debug("PROCESSED: ");
					dumpCmd(cmd);
					break;
				case CMD_WRITE:
				    dspsysWriteRegister(cmd.addr, &(cmd.data));
					Debug("PROCESSED: ");
					dumpCmd(cmd);
					break;
				default:
					Debug("Invalid Command");
					break;
			}
		}
	
  }
  //blinkforever();
  return 0;
}

