// Names of the accesible registers of the DSP 56k

// $0 Interrupt control register
#define ICR	0
// Individual bits of ICR
#define RREQ 0
#define TREQ 1
// bit 2 unused (set to zero always)
#define HF0 3
#define HF1 4
#define HM0 5
#define HM1 6
#define INIT 7


// $1 Control vector register
#define CVR 1
// Individual bits of CVR
#define HV0 0
#define HV1 1
#define HV2 2
#define HV3 3
#define HV4 4
// bit 6 unused (set to zero always)
#define HC 7

// $2 Interrupt status register
#undef ISR
#define ISR	2
// Individual bits of ISR
#define RXDF 0
#define RXDE 1
#define TRDY 2
#define HF2 3
#define HF3 4
// bit 5 unused (set to zero always)
#define DMA 6
#define HREQ 7

// $3 Interrupt vector register
#define IVR	3
// Individual bits of IVR
#define IVR0 0
#define IVR1 1
#define IVR2 2
#define IVR3 3
#define IVR4 4
#define IVR5 5
#define IVR6 6
#define IVR7 7


// $5..7 RXx / TXx 
#define RXH 5
#define RXM 6
#define RXL 7

#define TXH 5
#define TXM 6
#define TXL 7
