#ifndef __HOSTPORT_H__
#define __HOSTPORT_H__


//#define __HOSTPORT_DEBUG

// Include definitions for I/O ports
#include "avr/io.h"

// Address lines A0...A2 are lower bits of PORTF
#define A_PORT PORTA
#define A_PORT_DDR DDRA
#define A0 PA0
#define A1 PA1
#define A2 PA2
// Control lines HR!W, !HEN, !HREQ, !HACK are higher bits of PORTF
#define HEN PA6
#define HRW PA7

// Data lines D0..D7 are PORTA
#define D_PORT PORTC
#define D_PIN PINC
#define D_PORT_DDR DDRC
#define D0 PC0
#define D1 PC1
#define D2 PC2
#define D3 PC3
#define D4 PC4
#define D5 PC5
#define D6 PC6
#define D7 PC7


// Jumper lines JP0..JP3 are PORTF
#define JP_PORT PORTF
#define JP_PIN PINF
#define JP_PORT_DDR DDRF
#define JP0 PF0
#define JP1 PF1
#define JP2 PF2
#define JP3 PF3

#define HP_WRITE_ENABLE() A_PORT&=~(1<<HRW)	
#define HP_READ_ENABLE() A_PORT|=(1<<HRW)

#define HP_SETUP_ACCESS() A_PORT&=~(1<<HEN)
#define HP_PERFORM_ACCESS() A_PORT|=(1<<HEN)

/* Override default macroes for easier debugging */
#ifdef __HOSTPORT_DEBUG
#undef HP_PERFORM_ACCESS
#define HP_PERFORM_ACCESS() dspsysDebugHostport()
#endif // __HOSTPORT_DEBUG


#define RREQ 0
#define INIT 7

#define HC_BIT 7

#define TXDE 1
#define TRDY 2
#define HREQ 7

//#define HP_SEND_ACK() {A_PORT&=~(1<<HACK);asm {nop;nop;nop};A_PORT|=(1<<HACK)}
//#define HP_CALL_ISR() {A_PORT&=~(1<<HREQ);asm {nop;nop;nop};A_PORT|=(1<<HREQ)}




#endif
